org.apache.commons.math3.linear

## Interface FieldDecompositionSolver<T extends FieldElement<T>>

- Type Parameters:
    `T` - the type of the field elements
  All Known Implementing Classes:
    FieldLUDecomposition.Solver

      public interface FieldDecompositionSolver<T extends FieldElement<T>>

  Interface handling decomposition algorithms that can solve A × X = B.

  Decomposition algorithms decompose an A matrix has a product of several specific matrices from which they can solve A × X = B in least squares sense: they find X such that ||A × X - B|| is minimal.

  Some solvers like `FieldLUDecomposition` can only find the solution for square matrices and when the solution is an exact linear solution, i.e. when ||A × X - B|| is exactly 0. Other solvers can also find solutions with non-square matrix A and with non-null minimal norm. If an exact linear solution exists it is also the minimal norm solution.

  Since:
    2.0
  Version:
    $Id: FieldDecompositionSolver.java 1416643 2012-12-03 19:37:14Z tn $

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FieldMatrix<T>` | `getInverse()` Get the inverse (or pseudo-inverse) of the decomposed matrix.
    `boolean` | `isNonSingular()` Check if the decomposed matrix is non-singular.
    `FieldMatrix<T>` | `solve(FieldMatrix<T> b)` Solve the linear equation A × X = B for matrices A.
    `FieldVector<T>` | `solve(FieldVector<T> b)` Solve the linear equation A × X = B for matrices A.

- - ### Method Detail

    - #### solve

          FieldVector<T> solve(FieldVector<T> b)

      Solve the linear equation A × X = B for matrices A.

      The A matrix is implicit, it is provided by the underlying decomposition algorithm.

      Parameters:
        `b` - right-hand side of the equation A × X = B
      Returns:
        a vector X that minimizes the two norm of A × X - B
      Throws:
        `DimensionMismatchException` - if the matrices dimensions do not match.
        `SingularMatrixException` - if the decomposed matrix is singular.

    - #### solve

          FieldMatrix<T> solve(FieldMatrix<T> b)

      Solve the linear equation A × X = B for matrices A.

      The A matrix is implicit, it is provided by the underlying decomposition algorithm.

      Parameters:
        `b` - right-hand side of the equation A × X = B
      Returns:
        a matrix X that minimizes the two norm of A × X - B
      Throws:
        `DimensionMismatchException` - if the matrices dimensions do not match.
        `SingularMatrixException` - if the decomposed matrix is singular.

    - #### isNonSingular

          boolean isNonSingular()

      Check if the decomposed matrix is non-singular.
      Returns:
        true if the decomposed matrix is non-singular

    - #### getInverse

          FieldMatrix<T> getInverse()

      Get the inverse (or pseudo-inverse) of the decomposed matrix.
      Returns:
        inverse matrix
      Throws:
        `SingularMatrixException` - if the decomposed matrix is singular.

Copyright (c) 2003-2013 Apache Software Foundation